"use strict";

var images = ["images/bag.jpg","images/balloon.jpg","images/beer.jpg","images/book.jpg","images/box.jpg","images/house.jpg","images/matches.jpg",
"images/coffee.jpg","images/computer.png","images/cooker.jpg","images/deodorant1.jpg","images/deodorant2.jpg","images/duck.gif","images/fork.jpg","images/Hair-Straightener.jpg","images/hat.jpg",
"images/m&ms.jpg","images/marker.jpg","images/nail-polish.jpg","images/nike.jpg","images/oil.jpg","images/perfume.jpg","images/pillow.jpg","images/popsicle.jpg",
"images/roller-blades.jpeg","images/shampoo.jpg","images/shirt.png","images/sweater.jpg","images/tennis.jpg","images/toilet-paper.jpg","images/toilet-brush.jpg","images/toothbrush.jpeg","images/watch.jpeg",
"images/bicycle.png","images/book2.jpg","images/bow.jpg","images/bra.jpeg","images/chair.jpg","images/condoms.jpg",
"images/glasses.jpg","images/goggles.jpg","images/headphones.jpg","images/metrocard.jpg","images/mouse.jpg","images/pencil.jpeg","images/plastic-bag.jpg","images/sewing.jpg","images/soap.jpg",
"images/socks.jpg","images/sugar.jpeg","images/suspenders.jpg","images/thermos.jpg","images/toothpaste.jpg","images/tupper.jpg","images/underwear.jpg",]

var clicks = 0;

var blue = "#003BFF";
var magenta = "#FC05EC";
var yellow = "#FFF700";
var brown = "#916600";
var red = "#FF002B";
var green = "#05FC15";
var lightGreen = "#00FFD4";
var colors = [blue, magenta, yellow, brown, red, green, lightGreen];

var getRandom = function (array) {
	var i = parseInt(Math.random()*(array.length));
    return array[i];
}

var Width,
    Height;

var set_boundaries = function(){
  Width = ($( window ).width());
  Height = ($( window ).height());
};

var Range = function (min, max) {
	return Math.random() * (max - min) + min;
}

var resources = { html: $(".resource") };
var cart = { html: $("#cart_wrapper") };
var body = { html: $("body") };


// var posotion_products = function(){

// }

var resource_intervals = [];

var position_resources = function(){
		resources.html.each(function(){
		var leftPos = Range(0, Width-40);
		var topPos = Range(0, Height-40);
		var resource = $(this);
			resource.css({
				left: leftPos,
				top: topPos,	
			});
		resource_intervals.push(setInterval(function(){
		resource.css({ left: (leftPos + Range(-15, 15)),
				   	   top: (topPos - Range(-15,15))
					});
		},510));
	});
};

var clear_all_resource_intervals = function(){
	for(var i = 0; i < resource_intervals.length; i++){
		clearInterval(resource_intervals[i]);
	}
	resource_intervals = [];
}


var position_cart = function(){
	cart.html.css({
			left: Range(0, Width-200),
			top: Range(0, Height-200),	
		});
};

var CP = 0;  
var CC = 0;
var game_over = function(){
	body.html.css({"background":"black"});
	setTimeout(function () {
		var bought_product = document.createElement("div"); 
		bought_product.setAttribute("id", "bought_product");
		bought_product.setAttribute("style", "background-image:url(" + my_cart[CP] + ")");
		bought_product.style.left = Range(0, Width-110); 	
		bought_product.style.top = Range(0, Height-110); 	
		// body.html.append("<div id=\"bought_product\" style=\"background-image: url(" + my_cart[CC] + "); left:" + Range(0, Width-110) + "; top:" + Range(0, Height-110) + ";\"></div>");
	 	
	 	$("body").append(bought_product);
	 	CP++;

	 	setTimeout(function () {
			var bought_color = document.createElement("div"); 
		    bought_color.setAttribute("id", "bought_color"); 
		    bought_color.setAttribute("style", "background-color:" + my_cart_colors[CC]);
		    bought_color.style.left = Range(0, Width-110); 	
			bought_color.style.top = Range(0, Height-110); 

		    $("body").append(bought_color);
		    CC++;
			}, 100);
	// setTimeout(function () {
	// 	var bought_color = document.createElement("div"); 
	//     bought_color.setAttribute("id", "bought_color"); 
	//     bought_color.setAttribute("style", "background-color:" + my_cart_colors[CC]);


	    if (CP < my_cart.length) {
	         game_over();
	    }

	}, 50);
}

var the_end = false;


var delete_resource = function(){
	if ( document.getElementsByClassName("resource").length !== 0 ) {
		var new_resources_length = document.getElementsByClassName("resource").length;
		var new_resources = document.getElementsByClassName("resource");
		var i = parseInt(Math.random() * (new_resources_length));

		new_resources[i].setAttribute("id", "to_erase");
		
		$(new_resources[i]).children().css({"background-color": getRandom(colors)});
		$(new_resources[i]).css({"background-color": getRandom(colors),"border": "none"});
			setTimeout(function(){
			$(new_resources[i]).css({"opacity": "0"});	
			},600 );
	}	

	else {
		the_end = true;
	}		
	
};



var delete_range_of_resources = function(n){
	for(var i = 0; i < n; i++) {
		delete_resource();
	
	}
}

var newProduct = function(){
	var product = $("#cart_products");
	var random_img = getRandom(images);
	product.css({"background-image":"url("+ random_img +")"});
}

$( window ).resize(function() {
  clear_all_resource_intervals();
  set_boundaries();
  position_resources();
});

$(window).trigger('resize');




var time = function(around){

	var min = around - around/2.0;
	var max = around + around/2.0;

	return Math.round(Range(min, max)) * 100;
//	return (parseInt(Math.random()*(5))+1)* 1000;	
}

var cart_timeout_reference;
	
var cartTimer = function again(n){
	if ( document.getElementsByClassName("resource").length < 1 ) {
		cart.html.addClass("hidden");
		game_over();
		the_end = true;
		console.log("the_end");
		return
	}
	else {
	clearInterval(cart_timeout_reference);
	var seconds = time(n);
	//console.log(seconds);
	cart_timeout_reference = setTimeout(function(){
		cart.html.removeClass("hidden");
		position_cart();
		newProduct();
		if (clicks >=6 ){
			$("#add_to_cart").css({"background-color": getRandom(colors)});
		};
		if ( clicks >= 18){
			$("#cart_colors").css({"background-color": getRandom(colors)});
			$("#add_to_cart").css({"border": "none"});
		};

		if ( clicks >= 21){
			$("#cart_wrapper").css({"background-color": getRandom(colors), "border":"none"});
		};



		// Autopilot
		// setTimeout(function(){
		// 	$('#add_to_cart').trigger('click');
		// }, Range(100, 200));
		
		again(n);
	}, seconds);

	}
}

var erase_matches = function(){
	if (the_end == false) {
		setTimeout(function(){
			var matches = document.querySelectorAll("div#to_erase");
			$(matches).remove();
		},1200);
	}
	else {
		console.log("nothing to erase");
	}
};


var my_cart = [];
var my_cart_colors = [];

var bought_products = function(){
	var current_product = document.getElementById("cart_products");
	var style = current_product.currentStyle || window.getComputedStyle(current_product, false);
	var bought_product = style.backgroundImage.slice(10, -1); // I might need to change the numbers here if it's on the web.
	console.log(bought_product)
	my_cart.push(bought_product);

	if ( clicks > 18){
		var current_color = document.getElementById("cart_colors");
		var color_style = current_color.currentStyle || window.getComputedStyle(current_color, false);
		var bought_color = color_style.backgroundColor;
		my_cart_colors.push(bought_color);
 	}
}



$( window ).load(function() {
	position_resources();
	cartTimer(25);
	// animation_timer(14);
	$('#add_to_cart').hover(function(){
		$(this).css({"background-color": "black", "color" : "white"});	
	},
	function(){
		$(this).css({"background-color": "white", "color" : "black"});
	});

	$('#add_to_cart').click(function(){
		clicks ++;
		delete_range_of_resources(Range(1, 3));
		cart.html.addClass("hidden");
		erase_matches();
		console.log("clicks:" + clicks);
		bought_products();
		
		if ( clicks >= 10 && clicks < 13) {
			$("#add_to_cart").css({"font-size": "0px"});
			body.html.css({"background":"#FDFFCF"});
		}
		if ( clicks >= 13 && clicks < 18){
			body.html.css({"background":"#F5DDA4"});
			delete_range_of_resources(Range(1, 5));
		}
		if ( clicks >= 18  && clicks < 21){
			body.html.css({"background":"#F2B774"});
			$("#cart_products").addClass("hidden");
			$("#add_to_cart").css({"border": "none"});
			delete_range_of_resources(Range(1, 5));
		}
		if ( clicks >= 21 && clicks < 23){
			body.html.css({"background":"#E8A354"});
			delete_range_of_resources(Range(1, 5));
		}
		if ( clicks >= 23 && clicks < 26){
			body.html.css({"background":"#DB7A39"});
			delete_range_of_resources(Range(1, 7));
		}
		if ( clicks >= 26 && clicks < 28){
			body.html.css({"background":"#C44F27"});
			delete_range_of_resources(Range(1, 7));
		}
		if ( clicks >= 28 && clicks < 29){
			body.html.css({"background":"#631005"});
			delete_range_of_resources(Range(1, 7));
		}
		if ( clicks >= 29){
			body.html.css({"background":"black"});
			delete_range_of_resources(Range(1, 7));
		}
	});

});









